%{
===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================
%}
%evaluates an MFA and return the log p(x)
%bGPU ==1 means we use GPU
function likv = eval_mfa(X, MoFA, bGPU, NEWFORMULATION)

if nargin < 3 
    bGPU = 0;
end

if ~exist('NEWFORMULATION', 'var') || isempty(NEWFORMULATION)
   NEWFORMULATION = 1; 
end

if bGPU ==0
    LogLbits = ll_mfa(double(X), MoFA, [], NEWFORMULATION); % MxN
else
    clear mex;
    mfap.PreWts.W = single(MoFA.W);
    mfap.PreWts.M = single(MoFA.M);
    mfap.PreWts.Psi = single(MoFA.Psi);
    mfap.PreWts.mix = single(MoFA.mix');
    mfap.C = size(MoFA.M,2);
    mfap.d = size(MoFA.W,2);
    
    [Q LogLbits z zcov] =mexcuMFALL(single(X'), mfap);
    LogLbits = double(LogLbits);
end

likv = logsumexp(bsxfun(@plus, LogLbits, log(MoFA.mix)), 1);