%{
% xx = sample_mfa(MFA,N,noise);
%
% sample N points from the mfa
%
% if noise=1 then also sample from the diagonal noise models
%
% x = sample_mfa(mfa,n);

% Originally by Jakob Verbeek, Intelligent Systems Laboratory Amsterdam, 
% University of Amsterdam, 2005.
% http://www.science.uva.nl/~jverbeek

===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================
%}

function xx = sample_mfa(MFA,N,noise, prior_std)


if nargin==2; noise=0;end

if ~exist('prior_std', 'var')
   prior_std = 1; 
end

[D,d,C] = size(MFA.W);

cc      = rand(N,1);
cc      = sum(cc*ones(1,C) > ones(N,1)*cumsum([0 MFA.mix(1:end-1)']) , 2);

xx = zeros(D,N);

for c=1:C;

    ii = find(cc==c);
    n  = length(ii);
    yy = prior_std*randn(d,n); % sample factors
    
    xx(:,ii) = MFA.M(:,c)*ones(1,n)...
             + MFA.W(:,:,c)*yy...
             + noise*spdiags(MFA.Psi(:,c).^(1/2),0,D,D)*randn(D,n);
    
end








